//
//    File: iclass.appdata.twn.c
//    Date: 04/20/2009
// Version: 1
//
// Purpose:
//
// Read application data from a HID iClass card and send it to the host.
// This program can only be run on a TWN3 HID iClass.
//
// Feel free to modify this program for your specific purposes!
//
// V1:
// ---
// - Initial release

#include <sys.twn.h>

const byte MAXIDBYTES = 18;
const byte MAXIDBITS = MAXIDBYTES*8;

byte ID[MAXIDBYTES];
byte IDBitCnt;

byte LastID[MAXIDBYTES];
byte LastIDBitCnt;

void main()
{
    Beep(BEEPSUCCESS);
    SetVolume(4);
    LEDSet(GREEN,ON);
    LEDSet(RED,OFF);
    LastIDBitCnt = 0;
    while (TRUE)
    {
        if (IClassTagSearchApp(ID,IDBitCnt))
        {
            if (IDBitCnt != LastIDBitCnt || !CompBits(ID,LastID,MAXIDBITS))
            {
                Beep(BEEPHIGH);
                // Remove head and tail parity
                IDBitCnt -= 2;
                CopyBits(ID,0,ID,1,IDBitCnt);
                // Send FAC
                HostSendDec(ID,IDBitCnt-16,0);
                // Remove FAC
                CopyBits(ID,0,ID,IDBitCnt-16,16);
                // Send ID code as 5 decimal digits
                HostSendDec(ID,16,5);
                // Send enter
                HostSendChar('\r');
                LEDSet(GREEN,OFF);
                LEDSet(RED,BLINK);
                CopyBits(LastID,0,ID,0,MAXIDBITS);
                LastIDBitCnt = IDBitCnt;
            }
            StartTimer(0,20);
        }
        if (TestTimer(0))
        {
            LEDSet(GREEN,ON);
            LEDSet(RED,OFF);
            LastIDBitCnt = 0;
        }
    }
}
